local mod = ...



-- Building Asset Processor ------------------------------------------------------------------
mod:registerAssetProcessor("models/RusticChurch1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1RootPart", "PREFAB_CE_RUSTIC_CORE1_ROOT")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1BasementPart", "PREFAB_CE_RUSTIC_CORE1_BASEMENT")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1Tiling1Part", "PREFAB_CE_RUSTIC_CORE1_TILING1")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1Tiling2Part", "PREFAB_CE_RUSTIC_CORE1_TILING2")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1EndPart", "PREFAB_CE_RUSTIC_CORE1_END")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1BasementConstruction", "PREFAB_CE_RUSTIC_CORE1_BASEMENT_CONSTR")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1Tiling1Construction", "PREFAB_CE_RUSTIC_CORE1_TILING1_CONSTR")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1Tiling2Construction", "PREFAB_CE_RUSTIC_CORE1_TILING2_CONSTR")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core1EndConstruction", "PREFAB_CE_RUSTIC_CORE1_END_CONSTR")

-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2RootPart", "PREFAB_CE_RUSTIC_CORE2_ROOT")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2BasementPart", "PREFAB_CE_RUSTIC_CORE2_BASEMENT")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2Tiling1Part", "PREFAB_CE_RUSTIC_CORE2_TILING1")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2Tiling2Part", "PREFAB_CE_RUSTIC_CORE2_TILING2")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2EndPart", "PREFAB_CE_RUSTIC_CORE2_END")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2BasementConstruction", "PREFAB_CE_RUSTIC_CORE2_BASEMENT_CONSTR")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2Tiling1Construction", "PREFAB_CE_RUSTIC_CORE2_TILING1_CONSTR")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2Tiling2Construction", "PREFAB_CE_RUSTIC_CORE2_TILING2_CONSTR")
-- mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Core2EndConstruction", "PREFAB_CE_RUSTIC_CORE2_END_CONSTR")

mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Door1Part", "PREFAB_CE_RUSTIC_DOOR1")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Door1Construction", "PREFAB_CE_RUSTIC_DOOR1_CONSTR")

mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1RootPart", "PREFAB_CE_RUSTIC_EXTENSION1_ROOT")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1BasementPart", "PREFAB_CE_RUSTIC_EXTENSION1_BASEMENT")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1Tiling1Part", "PREFAB_CE_RUSTIC_EXTENSION1_TILING1")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1Tiling2Part", "PREFAB_CE_RUSTIC_EXTENSION1_TILING2")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1EndPart", "PREFAB_CE_RUSTIC_EXTENSION1_END")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1BasementConstruction", "PREFAB_CE_RUSTIC_EXTENSION1_BASEMENT_CONSTR")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1Tiling1Construction", "PREFAB_CE_RUSTIC_EXTENSION1_TILING1_CONSTR")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1Tiling2Construction", "PREFAB_CE_RUSTIC_EXTENSION1_TILING2_CONSTR")
mod:registerAssetId("models/RusticChurch1.fbx/Prefab/Extension1EndConstruction", "PREFAB_CE_RUSTIC_EXTENSION1_END_CONSTR")



-- Building Part Type ------------------------------------------------------------------
-- mod:registerEnumValue("BUILDING_PART_TYPE", "EXTENSION")

-- mod:registerPrefabComponent("models/RusticChurch1.fbx/Prefab/Core1BasementPart", {
-- 	DataType = "COMP_BUILDING_PART",
-- 	BuildingPartType = "MAJOR"
-- })

mod:registerPrefabComponent("models/RusticChurch1.fbx/Prefab/Door1Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "DOOR"
})



-- -- Attach nodes
-- for i = 1, 8, 1 do
--     mod:registerPrefabComponent("models/RusticChurch1.fbx/Prefab/Core1BasementPart/Attach_Major." .. string.format("%03d", i), { DataType = "COMP_BUILDING_ATTACH_NODE", AttachNodeTypeList = { "MAJOR" } })
--     -- mod:log("models/RusticChurch1.fbx/Prefab/Core1BasementPart/Attach_Major." .. string.format("%03d", i))
-- end

-- for i = 9, 12, 1 do
--     mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Extension1BasementPart/Attach_Extension." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_ATTACH_NODE", AttachNodeTypeList = { "EXTENSION" }, AllowedAngles = {-45, 45} })
--     -- mod:log("models/FrontierChurch1.fbx/Prefab/Extension1BasementPart/Attach_Extension." .. string.sub("000" .. i, -3))
-- end



-- Grounding
mod:registerPrefabComponent("models/RusticChurch1.fbx/Prefab/Door1Part", {DataType = "COMP_GROUNDED"})

-- for i=1, 4, 1 do
-- 	mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Core1Construction/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- end



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/FrontierKeep1.fbx/Prefab/KeepPart", { "PLATFORM" })



-- Building: Rustic Church (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "MONUMENT_RUSTIC_CHURCH",
	BuildingPartSetList = {
        Action = "APPEND",
		{
			Name = "MANDATORY",
			BuildingPartList = { 
				"BUILDING_PART_CE_RUSTIC_CORE1",
				-- "BUILDING_PART_CE_RUSTIC_CORE2",
				"BUILDING_PART_CE_RUSTIC_DOOR1",
			}
		},
        {
            Name = "ADDITIONNAL_PARTS",
            BuildingPartList = {
				"BUILDING_PART_CE_RUSTIC_EXTENSION1",
            }
        },
    }
})



-- Building Part: Core 1 Basement -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_CORE1_BASEMENT",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE1_BASEMENT"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE1_BASEMENT_CONSTR",
	Cost = {
        RessourcesNeeded = {
            { Resource = "STONE", Quantity = 8 },
		}
	}
})



-- Building Part: Core 1 Tiling 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_CORE1_TILING1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE1_TILING1"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE1_TILING1_CONSTR",
	Cost = {
        UpkeepCost = { { Resource = "GOLD", Quantity = 2 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "PLANK", Quantity = 4 },
            { Resource = "STONE", Quantity = 8 },
		}
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 1.00 },
    },
})



-- Building Part: Core 1 Tiling 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_CORE1_TILING2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE1_TILING2"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE1_TILING2_CONSTR",
	Cost = {
        UpkeepCost = { { Resource = "GOLD", Quantity = 2 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "PLANK", Quantity = 4 },
            { Resource = "STONE", Quantity = 8 },
		}
	}
})



-- Building Part: Core 1 End -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_CORE1_END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE1_END"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE1_END_CONSTR",
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 8 },
            { Resource = "PLANK", Quantity = 8 },
            { Resource = "STONE", Quantity = 8 },
		}
	}
})



-- Building Part: Core 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_CORE1",
	Name = "BUILDING_PART_CE_RUSTIC_CORE1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE1_ROOT",
		EndPart = "BUILDING_PART_CE_RUSTIC_CORE1_END",
		FillerList = {
		    "BUILDING_PART_CE_RUSTIC_CORE1_TILING2",
		    "BUILDING_PART_CE_RUSTIC_CORE1_TILING1",
    	},
		BasementFillerList = {
		    "BUILDING_PART_CE_RUSTIC_CORE1_BASEMENT",
       	},
		MinimumScale = 2,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {11.0, 7.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
    Capacity = 20,
    Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 20 } },
        UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        RessourcesNeeded = {
            { Resource = "TOOL", Quantity = 5 },
		}
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 2.00 },
    },
})



-- -- Building Part: Core 2 Basement -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_CE_RUSTIC_CORE2_BASEMENT",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE2_BASEMENT"
-- 	},
-- 	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE2_BASEMENT_CONSTR",
-- 	Cost = {
--         RessourcesNeeded = {
--             { Resource = "WOOD", Quantity = 8 },
-- 		}
-- 	}
-- })



-- -- Building Part: Core 2 Tiling 1 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_CE_RUSTIC_CORE2_TILING1",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE2_TILING1"
-- 	},
-- 	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE2_TILING1_CONSTR",
-- 	Cost = {
--         UpkeepCost = { { Resource = "GOLD", Quantity = 2 } },
--         RessourcesNeeded = {
--             { Resource = "WOOD", Quantity = 4 },
--             { Resource = "PLANK", Quantity = 12 },
-- 		}
-- 	},
--     EstateSplendor = {
--         { Estate = "CLERGY", Quantity = 1.00 },
--     },
-- })



-- -- Building Part: Core 2 Tiling 2 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_CE_RUSTIC_CORE2_TILING2",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE2_TILING2"
-- 	},
-- 	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE2_TILING2_CONSTR",
-- 	Cost = {
--         UpkeepCost = { { Resource = "GOLD", Quantity = 2 } },
--         RessourcesNeeded = {
--             { Resource = "WOOD", Quantity = 4 },
--             { Resource = "PLANK", Quantity = 12 },
-- 		}
-- 	}
-- })



-- -- Building Part: Core 2 End -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_CE_RUSTIC_CORE2_END",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE2_END"
-- 	},
-- 	ConstructionVisual = "PREFAB_CE_RUSTIC_CORE2_END_CONSTR",
-- 	Cost = {
--         RessourcesNeeded = {
--             { Resource = "WOOD", Quantity = 8 },
--             { Resource = "PLANK", Quantity = 16 },
-- 		}
-- 	}
-- })



-- -- Building Part: Core 2 -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_CE_RUSTIC_CORE2",
-- 	Name = "BUILDING_PART_CE_RUSTIC_CORE2_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_SCALER",
-- 		CoreObjectPrefab = "PREFAB_CE_RUSTIC_CORE2_ROOT",
-- 		EndPart = "BUILDING_PART_CE_RUSTIC_CORE2_END",
-- 		FillerList = {
-- 		    "BUILDING_PART_CE_RUSTIC_CORE2_TILING2",
-- 		    "BUILDING_PART_CE_RUSTIC_CORE2_TILING1",
--     	},
-- 		BasementFillerList = {
-- 		    "BUILDING_PART_CE_RUSTIC_CORE2_BASEMENT",
--        	},
-- 		MinimumScale = 2,
-- 		IsVertical = true
-- 	},
-- 	BuildingZone = { 
--         ZoneEntryList = {
--             { 
--                 Polygon = polygon.createRectangle( {11.0, 7.0}, {0.0, 0.0} ),
--                 Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
-- 			}, 
-- 		}
-- 	},
--     Capacity = 20,
--     Category = "CORE",
--     AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
-- 	Cost = {
--         -- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 20 } },
--         UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
--         RessourcesNeeded = {
--             { Resource = "TOOL", Quantity = 5 },
-- 		}
-- 	},
--     EstateSplendor = {
--         { Estate = "CLERGY", Quantity = 2.00 },
--     },
-- })



-- Building Part: Door 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_DOOR1",
	Name = "BUILDING_PART_CE_RUSTIC_DOOR1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_DOOR1",
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_DOOR1_CONSTR",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.0, 3.2}, {0.0, -0.6} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
    Category = "DOOR",
	Cost = {
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 },
		}
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 0.25 },
    },
})



-- Building Part: EXTENSION Basement -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_EXTENSION1_BASEMENT",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_EXTENSION1_BASEMENT"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_EXTENSION1_BASEMENT_CONSTR",
	Cost = {
        RessourcesNeeded = {
            { Resource = "STONE", Quantity = 4 },
		}
	}
})



-- Building Part: EXTENSION 1 Tiling 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_EXTENSION1_TILING1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_EXTENSION1_TILING1"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_EXTENSION1_TILING1_CONSTR",
	Cost = {
        UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "PLANK", Quantity = 2 },
            { Resource = "STONE", Quantity = 4 },
		}
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 0.50 },
    },
})



-- Building Part: EXTENSION 1 Tiling 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_EXTENSION1_TILING2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_EXTENSION1_TILING2"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_EXTENSION1_TILING2_CONSTR",
	Cost = {
        UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "PLANK", Quantity = 2 },
            { Resource = "STONE", Quantity = 4 },
		}
	}
})



-- Building Part: EXTENSION 1 End -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_EXTENSION1_END",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_EXTENSION1_END"
	},
	ConstructionVisual = "PREFAB_CE_RUSTIC_EXTENSION1_END_CONSTR",
	Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "PLANK", Quantity = 4 },
            { Resource = "STONE", Quantity = 4 },
		}
	}
})



-- Building Part: EXTENSION 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_CE_RUSTIC_EXTENSION1",
	Name = "BUILDING_PART_CE_RUSTIC_EXTENSION1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_CE_RUSTIC_EXTENSION1_ROOT",
		EndPart = "BUILDING_PART_CE_RUSTIC_EXTENSION1_END",
		FillerList = {
		    "BUILDING_PART_CE_RUSTIC_EXTENSION1_TILING2",
		    "BUILDING_PART_CE_RUSTIC_EXTENSION1_TILING1",
    	},
		BasementFillerList = {
		    "BUILDING_PART_CE_RUSTIC_EXTENSION1_BASEMENT",
       	},
		MinimumScale = 2,
		IsVertical = true
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {8.6, 5.2}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
    Capacity = 10,
    -- Category = "CORE",
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 20 } },
        UpkeepCost = { { Resource = "GOLD", Quantity = 5 } },
        -- RessourcesNeeded = {
        --     { Resource = "TOOL", Quantity = 5 },
		-- }
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 1.00 },
    },
})
